P1040题解

题目链接

这是一道区间DP题,当然你说他是树形DP题也行.因为这道题给的是中序遍历,所以说分清左右子树是很容易的,这为我们使用DP创造了机会. 这里我们假设dpij表示给出的序列中i到j最大的值.由于是中序遍历,只要这一串是子树那么无论哪个元素是根结点都可以.

因此状态转移方程为

我们用区间DP简单实现即可.这里注意dpii的值就是ai.

同时为了输出前序遍历我们记录一下每一段的根节点(root)

cpp 复制代码
#include <bits/stdc++.h>
#define int long long
using namespace std;
const int N=35;
int n,a[N],dp[N][N],root[N][N];
void work(int l, int r){
	if(l>r) return;
	cout<<root[l][r]<<' ';
	if(l==r) return;
	work(l,root[l][r]-1);
	work(root[l][r]+1,r);
}
signed main(){
	cin>>n;
	for(int i=1;i<=n;i++) cin>>a[i];
	for(int i=1;i<=n;i++) root[i][i]=i, dp[i][i-1]=1, dp[i][i]=a[i];
	for(int len=2;len<=n;len++){
		for(int i=1;i+len-1<=n;i++){
			int j=i+len-1;
			dp[i][j]=dp[i+1][j]+a[i], root[i][j]=i;
			for(int k=i+1;k<j;k++){
				if(dp[i][j]<dp[i][k-1]*dp[k+1][j]+a[k]){
					dp[i][j]=dp[i][k-1]*dp[k+1][j]+a[k];
					root[i][j]=k;
				}
			}
		}
	}cout<<dp[1][n]<<endl, work(1,n);
	return 0;
}
相关推荐
dialect_6 小时前
KMP算法
开发语言·c++·算法
reikocao6 小时前
卡尔曼滤波的动态机制:P如何改变融合权重
算法
漂流瓶jz7 小时前
UVA-1612 猜名次 题解答案代码 算法竞赛入门经典第二版
数据结构·算法·题解·排序·aoapc·算法竞赛入门经典
吞下星星的少年·-·8 小时前
Div.2 CF 1130B题(构造,贪心)
算法·贪心·构造
ShineWinsu8 小时前
对于Qt:QRadioButton常见属性以及QButtonGroup的解析
数据库·c++·qt·microsoft·gui·qradiobutton·qbuttongroup
傲世仙尊8 小时前
多态-虚表才活到运行期符号表早已消失
c++
chenbingjie_c9 小时前
C++ 多态完全指南:从虚函数重写到虚函数表原理
开发语言·c++
是main不是漫9 小时前
【双指针——移动零】数组划分类题目的入门基石
c++·算法
·present·9 小时前
CSAPP(Bomb lab)
c语言·c++
王老师青少年编程9 小时前
2026年信奥赛c++普及组csp-j第二轮复赛真题
c++·真题·csp·信奥赛